/*
 * @Cameron Giarrusso Board Feb 28, 2017
 */
package Monopoly.Board;

import Monopoly.Board.Space.Property;
import Monopoly.Board.Space.Space;
import Monopoly.Board.Space.Special;
import Monopoly.Cards.ChanceCard;
import Monopoly.Cards.CommunityChestCard;

/**
 *
 * @author fcg
 */
/*
* This class stores information about the 40 board spaces
 */
public class Board {

    private ChanceCard chance;
    private CommunityChestCard communityChest;
    public static Space[] BOARD = {
        
        Special.GO,
        Property.MEDITERRANEAN_AVENUE,
        Special.COMMUNITY_CHEST_1,
        Property.BALTIC_AVENUE,
        Special.INCOME_TAX,
        Special.READING_RAILROAD,
        Property.ORIENTAL_AVENUE,
        Special.CHANCE_1,
        Property.VERMONT_AVENUE,
        Property.CONNETICUT_AVENUE,
        Special.JAIL,
        Property.ST_CHARLES_PLACE,
        Special.ELECTRIC_COMPANY,
        Property.STATES_AVENUE,
        Property.VIRGINIA_AVENUE,
        Special.PENNSYLVANIA_RAILROAD,
        Property.ST_JAMES_PLACE,
        Special.COMMUNITY_CHEST_2,
        Property.TENNESSEE_AVENUE,
        Property.NEW_YORK_AVENUE,
        Special.FREE_PARKING,
        Property.KENTUCKY_AVENUE,
        Special.CHANCE_2,
        Property.INDIANA_AVENUE,
        Property.ILLINOIS_AVENUE,
        Special.BO_RAILROAD,
        Property.ATLANTIC_AVENUE,
        Property.VENTNOR_AVENUE,
        Special.WATER_WORKS,
        Property.MARVIN_GARDENS,
        Special.GO_TO_JAIL,
        Property.PACIFIC_AVENUE,
        Property.NORTH_CAROLINA_AVENUE,
        Special.COMMUNITY_CHEST_3,
        Property.PENNSYLVANIA_AVENUE,
        Special.SHORT_LINE,
        Special.CHANCE_3,
        Property.PARK_PLACE,
        Special.LUXURY_TAX,
        Property.BOARDWALK
        
    };
    
    public Space getNearest(Space[] spaces, int position) {
        Space startingSpace = getSpace(position);
        Space nearest = null;
        for (Space space : spaces) {
            if (nearest == null) {
                nearest = space;
            } else if (startingSpace.distanceTo(space) < startingSpace.distanceTo(nearest)) {
                nearest = space;
            }
        }
        return nearest;
    }
    
    public Space getSpace(int space) {
        return this.BOARD[space];
    }

    public ChanceCard getChance() {
        return chance;
    }

    public CommunityChestCard getCommunityChest() {
        return communityChest;
    }

    public Special[] getChances() {
        Special[] chances = new Special[3];

        chances[0] = Special.CHANCE_1;
        chances[1] = Special.CHANCE_2;
        chances[2] = Special.CHANCE_3;

        return chances;
    }

    public Special[] getCommunityChests() {
        Special[] chests = new Special[3];

        chests[0] = Special.COMMUNITY_CHEST_1;
        chests[1] = Special.COMMUNITY_CHEST_2;
        chests[2] = Special.COMMUNITY_CHEST_3;
        return chests;
    }

    public Special getGo() {
        return Special.GO;
    }

    public Special getJail() {
        return Special.JAIL;
    }

    public Special getFreeParking() {
        return Special.FREE_PARKING;
    }

    public Special getGoToJail() {
        return Special.GO_TO_JAIL;
    }

    public Special getIncomeTax() {
        return Special.INCOME_TAX;
    }

    public Special getLuxuryTax() {
        return Special.LUXURY_TAX;
    }

    public Special[] getRailroads() {
        Special[] railroads = new Special[4];
        railroads[0] = Special.READING_RAILROAD;
        railroads[1] = Special.PENNSYLVANIA_RAILROAD;
        railroads[2] = Special.BO_RAILROAD;
        railroads[3] = Special.SHORT_LINE;
        return railroads;
    }

    public Special getNearestRailroad(int location) {
        return (Special) getNearest(getRailroads(), location);
    }

    public Special[] getUtilities() {
        Special[] utilities = new Special[2];
        utilities[0] = Special.ELECTRIC_COMPANY;
        utilities[1] = Special.WATER_WORKS;
        return utilities;
    }

    public Special getNearestUtility(int location) {
        return (Special) getNearest(getUtilities(), location);
    }

    public Special getReadingRailroad() {
        return (Special) BOARD[5];
    }

    public Property getStCharlesPlace() {
        return (Property) BOARD[11];
    }

    public Property getIllinoisAvenue() {
        return (Property) BOARD[24];
    }

    public Property getBoardwalk() {
        return (Property) BOARD[39];
    }

}
