/*
 * @Cameron Giarrusso Executer May 7, 2017
 */
package Monopoly;

import Monopoly.Board.Board;

/**
 *
 * @author fcg
 */

//This class is in charge of taking in settings and applying them to the game
public class Executer {

    //This method resets all the postions for when a player simulates multpiple iterations from the same position
    public void reset(){
        Board board = new Board();
        for (int i = 0; i < 40; i++){
            board.getSpace(i).reset();
        }
    }
    
    //This Constructor is for when the player wants to start the game from a certain position
    public Executer(boolean useCards, int iterations, int turns, int startingPosition) {
        reset();
        Game game = new Game(useCards);
        Board board = new Board();

        for (int k = 0; k < iterations; k++) {
            for (int i = 0; i < turns; i++) {
                game.turn();
            }
            game.reset(startingPosition);
        }

//        This section of code was the old text UI
//        System.out.println("Starting Spot:\t\t\t\t" + board.getSpace(startingPosition).getName());
//        System.out.println("Number of Rolls:\t\t\t" + iterations);
//        System.out.println("Number of Iterations:\t\t\t" + turns);
//        System.out.println("Percentage of Doubles Rolls:\t\t" + (float) ((int) (1000 * ((float) game.getDoubles() / game.getRolls()))) / 10 + "%");
//        System.out.println("Percentage of Triple Doubles Rolls:\t" + (float) ((int) (1000 * ((float) game.getDoublesToJail() / game.getDoubles()))) / 10 + "%");
//        System.out.println("Number of Go Passes:\t\t\t" + game.getPastGo());
//        System.out.println("Card Draws:\t\t\t\t" + game.getCardDraws());
//        System.out.println("");
        
        int total = 0;
        for (int i = 0; i < 40; i++) {
            total += game.getBoard().getSpace(i).getLanded();
        }
        float average = total / 40f;
       for (int i = 0; i < 40; i++) {
            game.getBoard().getSpace(i).setRange((float) (((int) (1000 * ((float) game.getBoard().getSpace(i).getLanded() - average) / average))) / 10);
        }

    }

    //This Constructor is for when the player wants to start the game from go
    public Executer(boolean useCards, int turns) {
        //Flag to determine if the program is going to incorporate cards or not
        Game game = new Game(useCards);
        Board board = new Board();

        for (int i = 0; i < turns; i++) {
            game.turn();
        }
        
//        This section of code was the old text UI
//        System.out.println("Total Number of Rolls:\t\t\t" + game.getRolls());
//        System.out.println("Total Distance Travelled:\t\t" + game.getDistance());
//        System.out.println("Average Roll:\t\t\t\t" + ((int) ((float) game.getDistance() / game.getMoves())) + "." + (((int) (10 * ((float) game.getDistance() / game.getMoves()))) - (10 * (int) ((float) game.getDistance() / game.getMoves()))));
//        System.out.println("Total Number of Rolls In Jail:\t\t" + game.getRollsInJail());
//        System.out.println("Successful Rolls In Jail:\t\t" + (game.getDoublesInJail()));
//        System.out.println("Percentage of Successful Jail Rolls:\t" + (float) ((int) (1000 * ((float) game.getDoublesInJail() / game.getRollsInJail()))) / 10 + "%");
//        System.out.println("Total Number of Moves:\t\t\t" + game.getMoves());
//        System.out.println("Percentage of Doubles Rolls:\t\t" + (float) ((int) (1000 * ((float) game.getDoubles() / game.getRolls()))) / 10 + "%");
//        System.out.println("Percentage of Triple Doubles Rolls:\t" + (float) ((int) (1000 * ((float) game.getDoublesToJail() / game.getDoubles()))) / 10 + "%");
//        System.out.println("Number of Go Passes:\t\t\t" + game.getPastGo());
//        System.out.println("Card Draws:\t\t\t\t" + game.getCardDraws());
//        System.out.println("");
        int total = 0;
        for (int i = 0; i < 40; i++) {
            total += game.getBoard().getSpace(i).getLanded();
        }
        float average = total / 40f;
        for (int i = 0; i < 40; i++) {
            game.getBoard().getSpace(i).setRange((float) (((int) (1000 * ((float) game.getBoard().getSpace(i).getLanded() - average) / average))) / 10);
        }
    }
}
