/*
 * @Cameron Giarrusso GUI May 21, 2017
 */
package Monopoly;

/**
 *
 * @author fcg
 */
import Monopoly.Board.Board;
import java.awt.*;
import java.awt.image.BufferedImage;
import javax.swing.*;

//This class governs the GUI
public class GUI extends JPanel {

    //These are all the buttons that represent the spaces of the board
    private JButton go, mediterranianAvenue, communityChest1, balticAvenue, incomeTax, readingRailroad, orientalAvenue,
            chance1, vermontAvenue, connecticutAvenue, jailJustVisiting,
            stCharlesPlace, electricCompany, statesAvenue, virginiaAvenue,
            pennsylvaniaRailroad, stJamesPlace, communityChest2, tennesseeAvenue, newYorkAvenue,
            freeParking, kentuckyAvenue, chance2, indianaAvenue, illinoisAvenue,
            boRailroad, atlanticAvenue, ventnorAvenue, waterWorks, marvinGardens,
            goToJail, pacificAvenue, northCarolinaAvenue, communityChest3, pennsylvaniaAvenue, shortLine, chance3, parkPlace, luxuryTax, boardwalk;

    //They are arranges in an array to make calling and editing all of them easier
    private JButton[] spacesArray = {go, mediterranianAvenue, communityChest1, balticAvenue, incomeTax, readingRailroad, orientalAvenue,
        chance1, vermontAvenue, connecticutAvenue, jailJustVisiting,
        stCharlesPlace, electricCompany, statesAvenue, virginiaAvenue,
        pennsylvaniaRailroad, stJamesPlace, communityChest2, tennesseeAvenue, newYorkAvenue,
        freeParking, kentuckyAvenue, chance2, indianaAvenue, illinoisAvenue,
        boRailroad, atlanticAvenue, ventnorAvenue, waterWorks, marvinGardens,
        goToJail, pacificAvenue, northCarolinaAvenue, communityChest3, pennsylvaniaAvenue, shortLine, chance3, parkPlace, luxuryTax, boardwalk};

    //These are all the text, fields, and more that the user can interact with
    private JButton scaledButton, runnerButton, standardButton;
    private JToggleButton percentagesToggleButton;
    private JLabel iterationsLabel, turnsLabel, startingPositionLabel;
    private JTextField IterationsField, turnsField;
    private JCheckBox useCardsCheckBox;
    private JComboBox startingPositionComboBox;

    //These are the variables the program uses
    private Board board = new Board();
    private float divisor = 400f;
    private boolean useCards = true;
    private Executer execute;
    private int iterations = 1;
    private int turns = 1000000;
    private boolean contrast = false;
    private boolean percentages = true;
    private BufferedImage image;

    //The constructor sets up the board
    public GUI() {
        //construct components
        for (int i = 0; i < spacesArray.length; i++) {
            spacesArray[i] = new JButton();
            spacesArray[i].setOpaque(true);
        }

        //adjust size and set layout
        setPreferredSize(new Dimension(650, 650));
        setLayout(null);

        //add components
        for (int i = 0; i < spacesArray.length; i++) {
            add(spacesArray[i]);
        }

        //set component bounds (only needed by Absolute Positioning)
        components();

        //Starts the program with a default selection
        java.awt.event.ActionEvent evt = null;
        scaledButtonActionPerformed(evt);
    }

    //This methods sets up the boundaries for all of the utilities
    private void components() {
        
        //This sets up the positions for all the spaces on the GUI
        spacesArray[0].setBounds(550, 550, 100, 100);
        spacesArray[10].setBounds(0, 550, 100, 100);
        spacesArray[20].setBounds(0, 0, 100, 100);
        spacesArray[30].setBounds(550, 0, 100, 100);
        for (int i = 1; i < 10; i++) {
            spacesArray[i].setBounds(550 - (50 * i), 550, 50, 100);
        }
        for (int i = 11; i < 20; i++) {
            spacesArray[i].setBounds(0, 550 - (50 * (i - 10)), 100, 50);
        }
        for (int i = 21; i < 30; i++) {
            spacesArray[i].setBounds(50 + (50 * (i - 20)), 0, 50, 100);
        }
        for (int i = 31; i < 40; i++) {
            spacesArray[i].setBounds(550, 50 + (50 * (i - 30)), 100, 50);
        }

        //This sets the tooltext for all of the spaces
        spacesArray[0].setToolTipText("Go");
        spacesArray[1].setToolTipText("Mediterranean Avenue");
        spacesArray[3].setToolTipText("Baltic Avenue");
        spacesArray[2].setToolTipText("Community Chest");
        spacesArray[4].setToolTipText("Income Tax");
        spacesArray[6].setToolTipText("Oriental Avenue");
        spacesArray[5].setToolTipText("Reading Railroad");
        spacesArray[7].setToolTipText("Chance");
        spacesArray[10].setToolTipText("Jail/Just Visiting");
        spacesArray[9].setToolTipText("Connecticut Avenue");
        spacesArray[8].setToolTipText("Vermont Avenue");
        spacesArray[11].setToolTipText("St. Charles Place");
        spacesArray[12].setToolTipText("Electric Company");
        spacesArray[13].setToolTipText("States Avenue");
        spacesArray[14].setToolTipText("Virginia Avenue");
        spacesArray[15].setToolTipText("Pennsylvania Railroad");
        spacesArray[16].setToolTipText("St. James Place");
        spacesArray[17].setToolTipText("Community Chest");
        spacesArray[18].setToolTipText("Tenessee Avenue");
        spacesArray[19].setToolTipText("New York Avenue");
        spacesArray[20].setToolTipText("Free Parking");
        spacesArray[21].setToolTipText("Kentucky Avenue");
        spacesArray[22].setToolTipText("Chance");
        spacesArray[23].setToolTipText("Indiana Avenue");
        spacesArray[24].setToolTipText("Illinois Avenue");
        spacesArray[25].setToolTipText("B&O Railroad");
        spacesArray[26].setToolTipText("Atlantic Avenue");
        spacesArray[27].setToolTipText("Ventnor Avenue");
        spacesArray[28].setToolTipText("Water Works");
        spacesArray[29].setToolTipText("Marvin Gardens");
        spacesArray[30].setToolTipText("Go To Jail");
        spacesArray[39].setToolTipText("Boardwalk");
        spacesArray[31].setToolTipText("Pacific Avenue");
        spacesArray[32].setToolTipText("North Carolina Avenue");
        spacesArray[33].setToolTipText("Community Chest");
        spacesArray[34].setToolTipText("Pennsylvania Avenue");
        spacesArray[35].setToolTipText("Short Line");
        spacesArray[36].setToolTipText("Chance");
        spacesArray[37].setToolTipText("Park Place");
        spacesArray[38].setToolTipText("Luxury Tax");

        //This creates the buttons that the user will interact with
        scaledButton = new javax.swing.JButton("Scaled");
        runnerButton = new javax.swing.JButton("Run");
        useCardsCheckBox = new javax.swing.JCheckBox("Use Cards");
        startingPositionComboBox = new javax.swing.JComboBox<>();
        standardButton = new javax.swing.JButton("Standard");
        iterationsLabel = new javax.swing.JLabel("Iterations");
        turnsLabel = new javax.swing.JLabel("Turns");
        IterationsField = new javax.swing.JTextField();
        turnsField = new javax.swing.JTextField();
        startingPositionLabel = new javax.swing.JLabel("Starting Position:");
        percentagesToggleButton = new javax.swing.JToggleButton("Percentages");

        //This sets the position, tooltext, and actions that all the buttons do when they are pressed
        scaledButton.setBounds(250, 200, 150, 50);
        scaledButton.setToolTipText("Scales the colors to help contrast between the highest and lowest available buttons");
        scaledButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                scaledButtonActionPerformed(evt);
            }
        });
        add(scaledButton);
        percentagesToggleButton.setBounds(250, 150, 150, 50);
        percentagesToggleButton.setSelected(true);
        add(percentagesToggleButton);
        standardButton.setBounds(250, 250, 150, 50);
        standardButton.setToolTipText("Contrasts the difference between positive and negative values");
        standardButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                standardButtonActionPerformed(evt);
            }
        });
        add(standardButton);
        useCardsCheckBox.setBounds(250, 300, 150, 25);
        useCardsCheckBox.setSelected(true);
        useCardsCheckBox.setToolTipText("Do you want to incorporate Chance and Community Chest cards in the game?");
        useCardsCheckBox.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                useCardsCheckBoxStateChanged(evt);
            }
        });
        add(useCardsCheckBox);
        turnsLabel.setBounds(250, 325, 75, 25);
        turnsLabel.setToolTipText("How many turns are taken in one iterations, similar to the number of dice thrown");
        add(turnsLabel);
        turnsField.setBounds(325, 325, 75, 25);
        turnsField.setText("1000000");
        add(turnsField);
        iterationsLabel.setBounds(250, 350, 75, 25);
        iterationsLabel.setToolTipText("How many times a turn should be repeated, similar to the number of games played");
        add(iterationsLabel);
        IterationsField.setBounds(325, 350, 75, 25);
        IterationsField.setText("1");
        add(IterationsField);
        startingPositionLabel.setBounds(250, 375, 150, 25);
        percentagesToggleButton.setToolTipText("When toggled on, it will show the percentages relative to the average of how often the  spaces are landed on");
        percentagesToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                percentagesToggleButtonActionPerformed(evt);
            }
        });
        add(startingPositionLabel);
        startingPositionComboBox.setBounds(250, 400, 150, 25);
        startingPositionComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[]{"0 Go", "1 Mediterranean Avenue", "2 Community Chest", "3 Baltic Avenue", "4 Income Tax", "5 Reading Railroad", "6 Oriental Avenue", "7 Chance", "8 Vermont Avenue", "9 Connecticut Avenue", "10 Jail/Just Visiting", "11 St. Charles Place", "12 Electric Company", "13 States Avenue", "14 Virginia Avenue", "15 Pennsylvania Avenue", "16 St. James Place", "17 Community Chest", "18 Tennessee Avenue", "19 New York Avenue", "20 Free Parking", "21 Kentucky Avenue", "22 Chance", "23 Indiana Avenue", "24 Illinois Avenue", "25 B&O Railroad", "26 Atlantic Avenue", "27 Ventnor Avenue", "28 Water Works", "29 Marvin Gardens", "30 Go To Jail", "31 Pacific Avenue", "32 North Carolina Avenue", "33 Community Chest", "34 Pennsylvania Avenue", "35 Short Line", "36 Chance", "37 Park Place", "38 Luxury Tax", "39 Boardwalk"}));
        startingPositionComboBox.setToolTipText("The spot on the board you want to start on");
        add(startingPositionComboBox);
        runnerButton.setBounds(250, 425, 150, 50);
        runnerButton.setToolTipText("Run the simulation with the given inputs");
        runnerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runnerButtonActionPerformed(evt);
            }
        });
        add(runnerButton);
    }

    //This method recolors the spaces and scales them to the most deviant number from the mean
    private void scaledButtonActionPerformed(java.awt.event.ActionEvent evt) {
        divisor = (float) (findRange() / 0.153);
        contrast = true;

        for (int i = 0; i < 40; i++) {
            if (percentages) {
                spacesArray[i].setText("" + (int) board.getSpace(i).getRange());
            } else {
                spacesArray[i].setText("" + (int) board.getSpace(i).getLanded());
            }
            if (board.getSpace(i).getRange() < 0) {
                spacesArray[i].setBackground(Color.getHSBColor(0.153f + board.getSpace(i).getRange() / divisor, 1f, 1f));
            } else {
                spacesArray[i].setBackground(Color.getHSBColor(0.153f + board.getSpace(i).getRange() / divisor, 1f, 1f));
            }
        }
    }

    //This method colors the squares assuming -100% will always be dark red
    private void standardButtonActionPerformed(java.awt.event.ActionEvent evt) {
        contrast = false;

        for (int i = 0; i < 40; i++) {
            if (percentages) {
                spacesArray[i].setText("" + (int) board.getSpace(i).getRange());
            } else {
                spacesArray[i].setText("" + (int) board.getSpace(i).getLanded());
            }
            if (board.getSpace(i).getRange() < 0) {
                spacesArray[i].setBackground(Color.getHSBColor(0.153f + board.getSpace(i).getRange() / 653.6f, 1f, 1f));
            } else {
                spacesArray[i].setBackground(Color.getHSBColor(0.153f + board.getSpace(i).getRange() / 653.6f, 1f, 1f));
            }
        }
    }

    //This method checks if the user wants to use cards or not
    private void useCardsCheckBoxStateChanged(javax.swing.event.ChangeEvent evt) {
        if (useCards) {
            useCards = false;
        } else {
            useCards = true;
        }
    }

    //This method takes in the user input and runs an instance of Executer and redisplays the new game
    private void runnerButtonActionPerformed(java.awt.event.ActionEvent evt) {
        try {
            this.iterations = Integer.parseInt(this.IterationsField.getText());
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "Bad Iterations Number!", "Error", JOptionPane.ERROR_MESSAGE);
        }
        try {
            this.turns = Integer.parseInt(this.turnsField.getText());
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "Bad Turns Number!", "Error", JOptionPane.ERROR_MESSAGE);
        }

        execute = new Executer(useCards, iterations, turns, startingPositionComboBox.getSelectedIndex());
        if (contrast) {
            this.scaledButtonActionPerformed(evt);
        } else {
            this.standardButtonActionPerformed(evt);
        }
    }

    //This method changes the displayed number from the percentages relative to the average to the imperical number of times the space was landed on
    private void percentagesToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {
        if (percentages) {
            percentages = false;
        } else {
            percentages = true;
        }
        if (contrast) {
            this.scaledButtonActionPerformed(evt);
        } else {
            this.standardButtonActionPerformed(evt);
        }
    }

    //This method returns the most deviant number from the average number of times a space was landed on
    private float findRange() {
        float max = 0;
        for (int i = 0; i < 40; i++) {
            float temp = board.getSpace(i).getRange();
            if (temp < 0) {
                temp *= -1;
            }
            if (temp > max) {
                max = temp;
            }
        }
        return max;
    }

    //This main method creates the JFrame to display the entire program
    public static void main(String[] args) {
        Executer execute = new Executer(true, 1000000);

        JFrame frame = new JFrame("Cameron's Monopoly Simulator");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        GUI gui = new GUI();
        frame.getContentPane().add(gui);
        frame.pack();
        frame.setResizable(false);
        frame.setVisible(true);
    }
    
}
